/* ---------------------------------------------------------- */
/*  gamemain.c                                                */
/* ---------------------------------------------------------- */

/*--------------------------------------------------------*/
/*                                                        */
/* SDL puzzle project - for COMIKET62                     */
/*                        Fumi2Kick/LiMo/omamori-2002     */
/*                        1st Maintaner  Rerorero@fumi.   */
/*                                                        */
/*   gamemain.c                                           */
/*     Q[{̂̃Ct[                           */
/*                                                        */
/*--------------------------------------------------------*/

/*------------------------------------------------------------- */
/** @file
    @brief		Q[{̃Xebv
    @author		K.Kunikane (rerofumi)
    @since		Sep.20.2005
*/
/*-----------------------------------------------------
 Copyright (C) 2002,2005 rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <stdlib.h>
#include <math.h>

#include "gamemain.h"
#include "input.h"
#include "sound.h"
#include "debug.h"

/*-------------------------------*/
/* local value                   */
/*-------------------------------*/

/*-------------------------------*/
/* local function                */
/*-------------------------------*/

/* -------------------------------------------------------------- */
/* --- Q[CXebv                                       */
/* -------------------------------------------------------------- */

/* ---------------------------------------- */
/* --- RXgN^EfXgN^         */
TGameMain *TGameMain_Create(TGameScreen *mainscreen)
{
  TGameMain *class;

  class = malloc(sizeof(TGameMain));
  if (class == NULL) return(0);

  class->screen = mainscreen;
  class->step = CheckInit;

  return(class);
}

void TGameMain_Destroy(TGameMain *class)
{
  if (class == NULL) return;

  /* - ܂ */

  /* --- CX^X̉ */
  free(class);
}


/* ---------------------------------------- */
/* --- Q[C                         */
/* ---------------------------------------- */
int TGameMain_Poll(TGameMain *class,
		    int counter)
{
  int  skip;
  int  i;

  if (class == NULL) return(FALSE);

  skip = TRUE;

  /* -------------------------------- */
  /* --- Q[CXebv */
  
  switch(class->step) {

    /* -- ^Cg */
  case CheckInit:
#ifdef __GP2X__
    TGameScreen_LoadTexture(class->screen, 0, "check.png");
#else
    TGameScreen_LoadTexturePure(class->screen, 0, "check.png");
#endif
    for(i=0; i<ITEMMAX; i++) {
      class->item[i].dis_x = rand() % 2;
      class->item[i].dis_y = rand() % 2;
      if (class->item[i].dis_x == 0) {
	class->item[i].dis_x = -1;
      }
      if (class->item[i].dis_y == 0) {
	class->item[i].dis_y = -1;
      }
      class->item[i].timer = rand() % 128;
      class->item[i].spr = TGameScreen_GetSprite(class->screen, i);
      class->item[i].spr->DispSw = FALSE;
#ifdef __PSP_SCREEN__
      class->item[i].spr->x = rand() % (480-128);
      class->item[i].spr->y = rand() % (272-128);
#else
      class->item[i].spr->x = rand() % (320-128);
      class->item[i].spr->y = rand() % (240-128);
#endif
      class->item[i].spr->w = 128;
      class->item[i].spr->h = 128;
      class->item[i].spr->tx = 0;
      class->item[i].spr->ty = 0;
      class->item[i].spr->TextureId = 0;
      class->item[i].spr->Texture = TGameScreen_GetTexture(class->screen, 0);
      class->item[i].spr->alpha = 255;
      class->item[i].spr->rotation_z = 0.0;
    }
    class->item[0].spr->DispSw = TRUE;
    class->titletimer = 0;
    class->itemnum = 1;
    class->rotsw = FALSE;
    class->step = CheckMain;
    skip = FALSE;
    break;

    /* -- XvCg\eXg */
  case CheckMain:
    class->titletimer += 1;
    /* - L[ */
    if ((InputJoyKeyTriger(0) & IN_Up) != 0) {
      if (class->itemnum < (ITEMMAX - 1)) {
	class->itemnum += 1;
	class->item[class->itemnum].spr->DispSw = TRUE;
      }
    }
    if ((InputJoyKeyTriger(0) & IN_Down) != 0) {
      if (class->itemnum > 1) {
	class->item[class->itemnum].spr->DispSw = FALSE;
	class->itemnum -= 1;
      }
    }
    if ((InputJoyKeyTriger(0) & IN_Button1) != 0) {
      if (class->rotsw == TRUE) {
	class->rotsw = FALSE;
      }
      else {
	class->rotsw = TRUE;
      }
    }
    /* - \ */
    for(i=0; i<ITEMMAX; i++) {
      class->item[i].timer += 1;
      class->item[i].spr->alpha = 255;
      class->item[i].spr->y -= class->item[i].dis_y;
      if (class->item[i].spr->y < 0) {
	class->item[i].dis_y = (-1) * class->item[i].dis_y;
	class->item[i].spr->y -= class->item[i].dis_y;
      }
#ifdef __PSP_SCREEN__
      else if (class->item[i].spr->y >= (272-128)) {
#else
      else if (class->item[i].spr->y >= (240-128)) {
#endif
	class->item[i].dis_y = (-1) * class->item[i].dis_y;
	class->item[i].spr->y -= class->item[i].dis_y;
      }
      class->item[i].spr->x -= class->item[i].dis_x;
      if (class->item[i].spr->x < 0) {
	class->item[i].dis_x = (-1) * class->item[i].dis_x;
	class->item[i].spr->x -= class->item[i].dis_x;
      }
#ifdef __PSP_SCREEN__
      else if (class->item[i].spr->x >= (480-128)) {
#else
      else if (class->item[i].spr->x >= (320-128)) {
#endif
	class->item[i].dis_x = (-1) * class->item[i].dis_x;
	class->item[i].spr->x -= class->item[i].dis_x;
      }

      if ((i == 0) && (class->rotsw == TRUE)) {
	class->item[i].spr->rotation_z += 1.0;
	class->item[i].spr->zoomx = 1.4;
	class->item[i].spr->zoomy = 1.4;
	if (class->item[i].spr->rotation_z > 360.0) {
	  class->item[i].spr->rotation_z -= 360.0;
	}
      }
      else {
	class->item[i].spr->rotation_z = 0.0;
	class->item[i].spr->zoomx = 1.0;
	class->item[i].spr->zoomy = 1.0;
      }
    }
    break;

  }

  return(skip);
}
